function feature_string()
    llvmlib_path = VERSION ≥ v"1.6.0-DEV.1429" ? Base.libllvm_path() : only(filter(lib->occursin(r"LLVM\b", basename(lib)), Libdl.dllist()))
    libllvm = Libdl.dlopen(llvmlib_path)
    gethostcpufeatures = Libdl.dlsym(libllvm, :LLVMGetHostCPUFeatures)
    features_cstring = ccall(gethostcpufeatures, Cstring, ())
    features = filter(ext -> (ext ≠ "" && (m = match(r"\d", ext); isnothing(m) ? true : m.offset != 2)), split(unsafe_string(features_cstring), ','))
    features, features_cstring
end

const FEATURE_SET = Set{String}()
_has_feature(str::String) = str ∈ FEATURE_SET

archstr() = Sys.ARCH === :i686 ? "x86_64_" : string(Sys.ARCH) * '_'

# feature_name(ext) = archstr() * replace(ext[2:end], r"\." => "_")
feature_name(ext) = archstr() * ext[2:end]
process_feature(ext) = (feature_name(ext), first(ext) == '+')

has_feature(_) = False()
@noinline function set_feature(feature::String, has::Bool)
    featqn = QuoteNode(Symbol(feature))
    if has
        @eval has_feature(::Val{$featqn}) = True()
    else
        @eval has_feature(::Val{$featqn}) = False()
    end
end

function set_features!()
  features, features_cstring = feature_string()
  znver3 = get_cpu_name() === "znver3"
  for ext ∈ features
    feature, has = process_feature(ext)
    if znver3 && occursin("512", feature)
      has = false
    end
    has && push!(FEATURE_SET, feature)
    set_feature(feature, has)
  end
  Libc.free(features_cstring)
end
set_features!()



function reset_features!()
    features, features_cstring = feature_string()
    for ext ∈ features
        feature, has = process_feature(ext)
        if _has_feature(feature) ≠ has
            @debug "Defining $(has ? "presence" : "absense") of feature $feature."
            set_feature(feature, has)
        end
    end
    Libc.free(features_cstring)
end

register_size(::Type{T}) where {T} = register_size()
register_size(::Type{T}) where {T<:Union{Signed,Unsigned}} = simd_integer_register_size()

function define_cpu_name()
    cpu = QuoteNode(Symbol(get_cpu_name()))
    @eval cpu_name() = Val{$cpu}()
end
define_cpu_name()

_has_aarch64_sve() = (Base.libllvm_version ≥ v"11") && (Base.BinaryPlatforms.CPUID.test_cpu_feature(Base.BinaryPlatforms.CPUID.JL_AArch64_sve))

if Int === Int64
    @noinline vscale() = ccall("llvm.vscale.i64", llvmcall, Int64, ())
else
    @noinline vscale() = ccall("llvm.vscale.i32", llvmcall, Int32, ())
end

# TODO: find actually support SVE
# _dynamic_register_size() = _has_aarch64_sve() ? 16vscale() : 16
function _dynamic_register_size()
  _has_aarch64_sve() || return 16
  llvmargs = get(ENV, "JULIA_LLVM_ARGS", nothing)
  llvmargs === nothing && return 16
  m = match(r"--aarch64-sve-vector-bits-min=(\d+)", llvmargs)
  m === nothing && return 16
  length(m.captures) == 0 && return 16
  return max(16, parse(Int, last(m.captures)) ÷ 8)
end

function _set_sve_vector_width!(bytes = _dynamic_register_size())
    @eval begin
        register_size() = StaticInt{$bytes}()
        simd_integer_register_size() = StaticInt{$bytes}()
    end
    nothing
end


if _has_aarch64_sve()# && !(Bool(has_feature(Val(:aarch64_sve))))
    has_feature(::Val{:aarch64_sve_cpuid}) = True()
    _set_sve_vector_width!()
else
    # has_feature(::Val{:aarch64_svejl}) = False()
    register_size() = StaticInt{16}()
    simd_integer_register_size() = StaticInt{16}()
end

function reset_extra_features!()
    drs = _dynamic_register_size()
    register_size() ≠ drs && _set_sve_vector_width!(drs)
    hassve = _has_aarch64_sve()
    if hassve ≠ has_feature(Val(:aarch64_sve_cpuid))
        @eval has_feature(::Val{:aarch64_sve_cpuid}) = $(Expr(:call, hassve ? :True : :False))
    end
end

fma_fast() = True()
register_count() = StaticInt{32}()
has_opmask_registers() = has_feature(Val(:aarch64_sve_cpuid))

fast_int64_to_double() = True()

fast_half() = False()

fma_fast() = True()
register_size() = StaticInt{16}()
simd_integer_register_size() = StaticInt{16}()
register_count() = StaticInt{16}()
has_opmask_registers() = True()

reset_extra_features!() = nothing

fast_int64_to_double() = True()
fast_half() = False()

using HostCPUFeatures
using Test

@testset "HostCPUFeatures.jl" begin

  println("vector_width.jl")
  @time @testset "vector_width.jl" begin
    for T ∈ (Float32,Float64)
      @test @inferred(HostCPUFeatures.pick_vector_width(T)) * @inferred(HostCPUFeatures.static_sizeof(T)) === @inferred(HostCPUFeatures.register_size(T)) === @inferred(HostCPUFeatures.register_size())
    end
    for T ∈ (Int8,Int16,Int32,Int64,UInt8,UInt16,UInt32,UInt64)
      @test @inferred(HostCPUFeatures.pick_vector_width(T)) * @inferred(HostCPUFeatures.static_sizeof(T)) === @inferred(HostCPUFeatures.register_size(T)) === @inferred(HostCPUFeatures.simd_integer_register_size())
    end
    @test HostCPUFeatures.static_sizeof(BigFloat) === HostCPUFeatures.static_sizeof(Int)
    @test HostCPUFeatures.static_sizeof(Float32) === HostCPUFeatures.static_sizeof(Int32) === HostCPUFeatures.StaticInt(4)

    @test @inferred(HostCPUFeatures.pick_vector_width(Float64, Int32, Float64, Float32, Float64)) * HostCPUFeatures.static_sizeof(Float64) === @inferred(HostCPUFeatures.register_size())
    @test @inferred(HostCPUFeatures.pick_vector_width(Float64, Int32)) * HostCPUFeatures.static_sizeof(Float64) === @inferred(HostCPUFeatures.register_size())

    @test @inferred(HostCPUFeatures.pick_vector_width(Float32, Float32)) * HostCPUFeatures.static_sizeof(Float32) === @inferred(HostCPUFeatures.register_size())
    @test @inferred(HostCPUFeatures.pick_vector_width(Float32, Int32)) * HostCPUFeatures.static_sizeof(Float32) === @inferred(HostCPUFeatures.simd_integer_register_size())

    FTypes = (Float32, Float64)
    Wv = ntuple(i -> @inferred(HostCPUFeatures.register_size()) >> (i+1), Val(2))
    for (T, N) in zip(FTypes, Wv)
      W = @inferred(HostCPUFeatures.pick_vector_width(T))
      # @test Vec{Int(W),T} == HostCPUFeatures.pick_vector(W, T) == HostCPUFeatures.pick_vector(T)
      @test W == @inferred(HostCPUFeatures.pick_vector_width(W, T))
      @test W === @inferred(HostCPUFeatures.pick_vector_width(W, T)) == @inferred(HostCPUFeatures.pick_vector_width(T))
      while true
        W >>= HostCPUFeatures.One()
        W == 0 && break
        W2, Wshift2 = @inferred(HostCPUFeatures.pick_vector_width_shift(W, T))
        @test W2 == HostCPUFeatures.One() << Wshift2 == @inferred(HostCPUFeatures.pick_vector_width(W, T)) == HostCPUFeatures.pick_vector_width(Val(Int(W)),T)  == W
        @test HostCPUFeatures.StaticInt(W) === HostCPUFeatures.pick_vector_width(Val(Int(W)), T) === HostCPUFeatures.pick_vector_width(W, T)
        for n in W+1:2W
          W3, Wshift3 = HostCPUFeatures.pick_vector_width_shift(HostCPUFeatures.StaticInt(n), T)
          @test W2 << 1 == W3 == 1 << (Wshift2+1) == 1 << Wshift3 == HostCPUFeatures.pick_vector_width(HostCPUFeatures.StaticInt(n), T) == HostCPUFeatures.pick_vector_width(Val(n),T) == W << 1
          # @test HostCPUFeatures.pick_vector(W, T) == HostCPUFeatures.pick_vector(W, T) == Vec{Int(W),T}
        end
      end
    end
    @test HostCPUFeatures.pick_vector_width(Float16) === HostCPUFeatures.pick_vector_width(Float32)
    # @test HostCPUFeatures.nextpow2(0) == 1

    @test HostCPUFeatures.unwrap(HostCPUFeatures.static(2)) === 2
    @test HostCPUFeatures.unwrap(HostCPUFeatures.static(1.2)) === 1.2
    @test HostCPUFeatures.unwrap(HostCPUFeatures.static(:a)) === :a
  end

end

@static if isdefined(Base, Symbol("@constprop"))
  using Base: @constprop
else
  macro constprop(_, ex); esc(ex); end
end

@generated function static_sizeof(::Type{T}) where {T}
  st = Base.allocatedinline(T) ? sizeof(T) : sizeof(Int)
  Expr(:block, Expr(:meta, :inline), StaticInt(st))
end

smax(a::StaticInt, b::StaticInt) = ifelse(gt(a, b), a, b)
smin(a::StaticInt, b::StaticInt) = ifelse(lt(a, b), a, b)

_pick_vector_width_float16(::StaticInt{RS}, ::True) where {RS} = StaticInt{RS}() ÷ StaticInt{2}()
_pick_vector_width_float16(::StaticInt{RS}, ::False) where {RS} = StaticInt{RS}() ÷ StaticInt{4}()
pick_vector_width(::Type{Float16}) = _pick_vector_width_float16(register_size(Float32), fast_half())
pick_vector_width(::Type{T}) where {T} = register_size(T) ÷ static_sizeof(T)
@inline @constprop :aggressive function _pick_vector_width(min_W, max_W, ::Type{T}, ::Type{S}, args::Vararg{Any,K}) where {K,S,T}
  _max_W = smin(max_W, pick_vector_width(T))
  _pick_vector_width(min_W, _max_W, S, args...)
end
@inline @constprop :aggressive function _pick_vector_width(min_W, max_W, ::Type{T}) where {T}
  _max_W = smin(max_W, pick_vector_width(T))
  smax(min_W, _max_W)
end
@inline @constprop :aggressive function pick_vector_width(::Type{T}, ::Type{S}, args::Vararg{Any,K}) where {T,S,K}
  _pick_vector_width(One(), register_size(), T, S, args...)
end
@inline @constprop :aggressive function pick_vector_width(::Union{Val{P},StaticInt{P}}, ::Type{T}, ::Type{S}, args::Vararg{Any,K}) where {P,T,S,K}
  _pick_vector_width(One(), smin(register_size(), nextpow2(StaticInt{P}())), T, S, args...)
end
@inline @constprop :aggressive function pick_vector_width(::Union{Val{P},StaticInt{P}}, ::Type{T}) where {P,T}
  _pick_vector_width(One(), smin(register_size(), nextpow2(StaticInt{P}())), T)
end
@inline function pick_vector_width_shift(args::Vararg{Any,K}) where {K}
  W = pick_vector_width(args...)
  W, intlog2(W)
end

fma_fast() = has_feature(Val(:x86_64_fma)) | has_feature(Val(:x86_64_fma4))
register_size() = ifelse(
    has_feature(Val(:x86_64_avx512f)),
    StaticInt{64}(),
    ifelse(
        has_feature(Val(:x86_64_avx)),
        StaticInt{32}(),
        StaticInt{16}()
    )
)
const simd_integer_register_size = register_size
# simd_integer_register_size() = ifelse(
#     has_feature(Val(:x86_64_avx2)),
#     register_size(),
#     ifelse(
#         has_feature(Val(:x86_64_sse2)),
#         StaticInt{16}(),
#         StaticInt{8}()
#     )
# )
if Sys.ARCH === :i686
    register_count() = StaticInt{8}()
elseif Sys.ARCH === :x86_64
    register_count() = ifelse(has_feature(Val(:x86_64_avx512f)), StaticInt{32}(), StaticInt{16}())
end
has_opmask_registers() = has_feature(Val(:x86_64_avx512f))

reset_extra_features!() = nothing

fast_int64_to_double() = has_feature(Val(:x86_64_avx512dq))

fast_half() = False()

@noinline function setfeaturefalse(s)
  if has_feature(Val(s)) === True()
    @eval has_feature(::Val{$(QuoteNode(s))}) = False()
  end
end
@noinline function setfeaturetrue(s)
  if has_feature(Val(s)) === False()
    @eval has_feature(::Val{$(QuoteNode(s))}) = True()
  end
end

function make_generic(target)
  if occursin("tigerlake", target) || occursin("znver4", target) || occursin("sapphirerapids", target)
    # most feature-complete architectures we use
    setfeaturetrue(:x86_64_avx512ifma)
    setfeaturetrue(:x86_64_avx512vl)
    setfeaturetrue(:x86_64_avx512bw)
    setfeaturetrue(:x86_64_avx512dq)
    setfeaturetrue(:x86_64_avx512f)
    setfeaturetrue(:x86_64_avx2)
    setfeaturetrue(:x86_64_bmi2)
    setfeaturetrue(:x86_64_fma)
    setfeaturetrue(:x86_64_avx)
  elseif occursin("icelake", target) || occursin("skylake-avx512", target) || occursin("rocketlake", target) || occursin("cascadelake", target)
    # no ifma, but avx512f and avx512dq
    setfeaturefalse(:x86_64_avx512ifma)
    setfeaturetrue(:x86_64_avx512vl)
    setfeaturetrue(:x86_64_avx512bw)
    setfeaturetrue(:x86_64_avx512dq)
    setfeaturetrue(:x86_64_avx512f)
    setfeaturetrue(:x86_64_avx2)
    setfeaturetrue(:x86_64_bmi2)
    setfeaturetrue(:x86_64_fma)
    setfeaturetrue(:x86_64_avx)
  elseif occursin("znver", target) || occursin("lake", target) || occursin("well", target)
    # no avx512, but avx2, fma, and bmi2
    # znver tries to capture all zen < 4
    # lake tries to capture lakes we didn't single out above as having avx512
    # 
    setfeaturefalse(:x86_64_avx512ifma)
    setfeaturefalse(:x86_64_avx512vl)
    setfeaturefalse(:x86_64_avx512bw)
    setfeaturefalse(:x86_64_avx512dq)
    setfeaturefalse(:x86_64_avx512f)
    setfeaturetrue(:x86_64_avx2)
    setfeaturetrue(:x86_64_bmi2)
    setfeaturetrue(:x86_64_fma)
    setfeaturetrue(:x86_64_avx)
  elseif occursin("ivybridge", target) || occursin("sandybridge", target)
    # has avx, and that is about it we care about
    setfeaturefalse(:x86_64_avx512ifma)
    setfeaturefalse(:x86_64_avx512vl)
    setfeaturefalse(:x86_64_avx512bw)
    setfeaturefalse(:x86_64_avx512dq)
    setfeaturefalse(:x86_64_avx512f)
    setfeaturefalse(:x86_64_avx2)
    setfeaturefalse(:x86_64_bmi2)
    setfeaturefalse(:x86_64_fma)
    setfeaturetrue(:x86_64_avx)
  else
    # hopefully we didn't miss something
    # TODO: sapphire rapids
    setfeaturefalse(:x86_64_avx512ifma)
    setfeaturefalse(:x86_64_avx512vl)
    setfeaturefalse(:x86_64_avx512bw)
    setfeaturefalse(:x86_64_avx512dq)
    setfeaturefalse(:x86_64_avx512f)
    setfeaturefalse(:x86_64_avx2)
    setfeaturefalse(:x86_64_bmi2)
    setfeaturefalse(:x86_64_fma)
    setfeaturefalse(:x86_64_avx)
  end
  return nothing
end

module HostCPUFeatures
if isdefined(Base, :Experimental) &&
   isdefined(Base.Experimental, Symbol("@max_methods"))
    @eval Base.Experimental.@max_methods 1
end

using Libdl, Static
using Static: Zero, One, lt, gt
using IfElse: ifelse

using BitTwiddlingConvenienceFunctions: prevpow2, nextpow2, intlog2

export has_feature, fma_fast, pick_vector_width, pick_vector_width_shift, register_count,
  register_size, simd_integer_register_size

function get_cpu_name()::String
  if isdefined(Sys, :CPU_NAME)
    Sys.CPU_NAME
  else
    ccall(:jl_get_cpu_name, Ref{String}, ())
  end
end
include("cpu_info.jl")
if (Sys.ARCH === :x86_64) || (Sys.ARCH === :i686)
    include("cpu_info_x86.jl")
elseif Sys.ARCH === :aarch64
    include("cpu_info_aarch64.jl")
else
    include("cpu_info_generic.jl")
end
include("pick_vector_width.jl")

unwrap(::Val{S}) where {S} = S
unwrap(::StaticInt{S}) where {S} = S
unwrap(::StaticFloat64{S}) where {S} = S
unwrap(::StaticSymbol{S}) where {S} = S

@noinline function redefine()
  @debug "Defining CPU name."
  define_cpu_name()

  reset_features!()
  reset_extra_features!()
end
const BASELINE_CPU_NAME = get_cpu_name()
function __init__()
  ccall(:jl_generating_output, Cint, ()) == 1 && return
  if Sys.ARCH === :x86_64 || Sys.ARCH === :i686
    target = Base.unsafe_string(Base.JLOptions().cpu_target)
    occursin("native",  target) || return make_generic(target)
  end
  BASELINE_CPU_NAME == Sys.CPU_NAME::String || redefine()
  return nothing
end

end

```@meta
CurrentModule = HostCPUFeatures
```

# HostCPUFeatures

Documentation for [HostCPUFeatures](https://github.com/JuliaSIMD/HostCPUFeatures.jl).

```@index
```

```@autodocs
Modules = [HostCPUFeatures]
```
